/*
 * This is a plug-in for the GIMP.
 *
 * Generates clickable image maps.
 *
 * Copyright (C) 1998-1999 Maurits Rijk  lpeek.mrijk@consunet.nl
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#ifndef _IMAP_SETTINGS_H
#define _IMAP_SETTINGS_H

#include "imap_browse.h"
#include "imap_default_dialog.h"

typedef struct {
   DefaultDialog_t *dialog;
   BrowseWidget_t *imagename;
   GtkWidget	*filename;
   GtkWidget	*title;
   GtkWidget	*author;
   GtkWidget	*default_url;
   GtkWidget	*description;
   GtkWidget	*ncsa;
   GtkWidget	*cern;
   GtkWidget	*csim;
} SettingsDialog_t;

void do_settings_dialog(void);

#endif /* _IMAP_SETTINGS_H */
